(* Syntaxe abstraite pour le langage Arith *)
(* Ast with localisation *)

open Base

type program = decl list 

and decl = decl_raw loc
and decl_raw = 
  | Vdecl of string * expr 
  | Fdecl of string * (string * asa_typ) list * asa_typ * expr

and expr = expr_raw loc
and expr_raw = 
  | Cst of cte
  | Var of string
  | Binop of op * expr * expr
  | Letin of string * expr * expr
  | If of expr * expr * expr
  | Call of string * expr list
